#!/usr/bin/php
<?

# This is a Plugin for SYSUSAGE
# Please refer with all questions to http://sysusage.darold.net/
#
# Created by Pavel Niederle
# http://www.niederle.eu/
#

$ls_url = 'http://www.YOURWEB.COM/nginx_status';

function f_coal($as_what,$as_newval)
{
	$ls_1 = $as_what;
	if($as_what == "" or !IsSet($as_what))
	{
		$ls_1 = $as_newval;
	}
	return $ls_1;
}

function f_only_number($al_what, $al_new = '', $ab_real = false)
{
	$ll_res = f_coal(eregi_replace('[^0-9' . (($ab_real) ? '.' : '') . ']','',str_replace(',','.',$al_what)),$al_new);
	if(is_numeric($ll_res)) return $ll_res; else return $al_new;
};


function curl_get_file_contents($URL)
{
	$c = curl_init();
	curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($c, CURLOPT_URL, $URL);
	$contents = curl_exec($c);
	curl_close($c);
	if ($contents) return $contents; else return FALSE;
}

function f_get_nginx_status($ls_url)
{
	$ls_text_include = '';

	$ls_file = curl_get_file_contents($ls_url);
	if(!$ls_file)
	{
		//$ls_text_include = 'Could not get the NGINX status at ' . $ls_url . ' ! Documentation available at http://wiki.nginx.org/HttpStubStatusModule ...';
		echo '0 0' . PHP_EOL;
		exit;
	}
	else
	{
		$ls_diacritics = 'ؚݞߥ';
		$regs = array();
		mb_eregi(iconv('windows-1250', 'UTF-8', 'Active connections: ([0-9]*)[[:space:]]*server accepts handled requests[[:space:]]*([0-9]*)[[:space:]]*([0-9]*)[[:space:]]*([0-9]*)[[:space:]]*Reading: ([0-9]*) Writing: ([0-9]*) Waiting: ([0-9]*)'), $ls_file, $regs);
		$ll_connections_active = f_only_number(iconv('UTF-8', 'windows-1250', Trim($regs[1])));
		$ll_connections_accepted_total = f_only_number(iconv('UTF-8', 'windows-1250', Trim($regs[2])));
		$ll_connections_handled_total = f_only_number(iconv('UTF-8', 'windows-1250', Trim($regs[3])));
		$ll_requests_total = f_only_number(iconv('UTF-8', 'windows-1250', Trim($regs[4])));
		$ll_requests_per_connection_average = $ll_requests_total / $ll_connections_accepted_total;
		$ll_connections_not_handled_total = $ll_connections_accepted_total - $ll_connections_handled_total;
		$ll_connections_reading = f_only_number(iconv('UTF-8', 'windows-1250', Trim($regs[5])));
		$ll_connections_writing = f_only_number(iconv('UTF-8', 'windows-1250', Trim($regs[6])));
		$ll_connections_waiting = f_only_number(iconv('UTF-8', 'windows-1250', Trim($regs[7])));

		$ls_text_include .= (($ls_text_include != '') ? ' ' : '') . $ll_connections_reading;
		$ls_text_include .= (($ls_text_include != '') ? ' ' : '') . $ll_connections_writing;
		$ls_text_include .= (($ls_text_include != '') ? PHP_EOL : '');
	}

	return $ls_text_include;
}

echo f_get_nginx_status($ls_url);

?>
